///twitch_http()
//must be in the Asynchronous>HTTP Event
//returns false when no info is received, 1 when viewers are received and 2 when followers are received








//check if we are in the Asynchronous Event
if(event_number != 62){
    show_debug_message("Twitch: Http Script have to be in the Asynchronous Event");
    return false;
}


var mode = false;

if(async_load[? "status"]==0){
    
    if(async_load[? "id"] == global.twitch_http_1){
        var json = json_decode(string(async_load[? "result"]));
        if(!ds_exists(json, ds_type_map))
            return false;
        
        
        var chatters    = json[? "chatters"];
        var viewers     = chatters[? "viewers"];
        var mods        = chatters[? "moderators"];
        var admins      = chatters[? "admins"];
        var oldViewers  = global.twitch_info[? "viewers"];
        
        //copy mods and admins to the viewers
        for(var i=0; i<ds_list_size(mods); i++){
            ds_list_add(viewers, mods[| i]);
        }
        for(var i=0; i<ds_list_size(admins); i++){
            ds_list_add(viewers, admins[| i]);
        }
            
        //check connected - disconnected
        //clear (dis)connected
        ds_list_clear(global.twitch_info[? "connected"]);
        ds_list_clear(global.twitch_info[? "disconnected"]);
        if(ds_list_size(oldViewers)>0){ //so that connected havn't all viewers at the beginning
            //check disconnected
            for(var i=0; i<ds_list_size(oldViewers); i++){
                var exists = -1;
                for(var j=0; j<ds_list_size(viewers); j++){
                    if(oldViewers[| i] == viewers[| j]){
                        exists = true;
                        break;
                    }
                }
                if(exists<0){
                    ds_list_add(global.twitch_info[? "disconnected"], oldViewers[| i]);
                    ds_list_delete(global.twitch_info[? "viewers"], i);
                }
            }
            //check connected
            for(var i=0; i<ds_list_size(viewers); i++){
                var exists = false;
                for(var j=0; j<ds_list_size(oldViewers); j++){
                    if(viewers[| i] == oldViewers[| j]){
                        exists = true;
                        break;
                    }
                }
                if(!exists){
                    ds_list_add(global.twitch_info[? "connected"], viewers[| i]);
                    ds_list_add(global.twitch_info[? "viewers"], viewers[| i])
                }
            }
        }
        else
            ds_list_copy(global.twitch_info[? "viewers"],viewers);
        
        ds_list_copy(global.twitch_info[? "mods"],chatters[? "moderators"]);
        ds_list_copy(global.twitch_info[? "admins"],chatters[? "admins"]);
        mode = 1;
        ds_map_destroy(json);
        
        if(global.twitch_autoreload)
            twitch_request_info();
    }
    
}
return mode;

